10. Regular Expression Matching
难度: Hard
刷题内容
原题连接
- https://leetcode.com/problems/regular-expression-matching
内容描述
Given an input string (s) and a pattern (p), implement regular expression matching with support for '.' and '*'.
'.' Matches any single character.
'*' Matches zero or more of the preceding element.
The matching should cover the entire input string (not partial).
Note:
s could be empty and contains only lowercase letters a-z.
p could be empty and contains only lowercase letters a-z, and characters like . or *.
Example 1:
Input:
s = "aa"
p = "a"
Output: false
Explanation: "a" does not match the entire string "aa".
Example 2:
Input:
s = "aa"
p = "a*"
Output: true
Explanation: '*' means zero or more of the precedeng element, 'a'. Therefore, by repeating 'a' once, it becomes "aa".
Example 3:
Input:
s = "ab"
p = ".*"
Output: true
Explanation: ".*" means "zero or more (*) of any character (.)".
Example 4:
Input:
s = "aab"
p = "c*a*b"
Output: true
Explanation: c can be repeated 0 times, a can be repeated 1 time. Therefore it matches "aab".
Example 5:
Input:
s = "mississippi"
p = "mis*is*p*."
Output: false
解题方案
思路1 **- 时间复杂度: O(n^2)*- 空间复杂度: O(n^2)***
用动态规划的思路去解,dp[i][j]代表字符串s中第i个字符之前的字符串与p中第j个字符串之前的字符是否匹配。写出状态转移方程。当s[i] == p[j] || p[j] == '.'
时。dp[i + 1][j + 1] = dp[i][j]
。当p[j] == '*'
时,可以匹配0个,1个或多个之前相同的字符。当之前的字符s[i] == p[j - 1] || p[j - 1] == '*'
时。dp[i + 1][j + 1] = dp[i][j] || dp[i][j + 1]
表示匹配1个或者多个。还可匹配0个。因此dp[i + 1][j + 1] = dp[i + 1][j + 1] || dp[i + 1][j - 1]
class Solution {
public:
bool isMatch(string s, string p) {
s.push_back(' ');
p.push_back(' ');
int len1 = s.length(),len2 = p.length();
int dp[len1 + 1][len2 + 1];
memset(dp,0,sizeof(dp));
dp[0][0] = 1;
for(int i = 1;i < len2;++i)
if(p[i] == '*')
dp[0][i + 1] = dp[0][i - 1];
for(int i = 0;i < len1;++i)
for(int j = 0;j < len2;++j)
if(j && p[j] == '*')
{
dp[i + 1][j + 1] = (p[j - 1] == s[i] || p[j - 1] == '.') && (dp[i][j] || dp[i][j + 1]);
dp[i + 1][j + 1] = dp[i + 1][j + 1] || dp[i + 1][j - 1];
}
else if(s[i] == p[j] || p[j] == '.')
dp[i + 1][j + 1] = dp[i][j];
return dp[len1][len2];
}
};